//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * テストケーステストヘッダ
 * @author Junpee
 */

#ifndef TEST_CASE_TEST_H_
#define TEST_CASE_TEST_H_

#include <LampUnit/TestCase.h>

//------------------------------------------------------------------------------
/**
 * テストケーステスト
 */
class TestCaseTest : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit TestCaseTest(String name) : TestCase(name){}

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// テストケーステスト
	void testCaseTest();

	// アサートテスト
	void testAssert();

	// アサートイコールテスト
	void testAssertEquals();

	// アサートノットイコールテスト
	void testAssertNotEquals();

	// 成功するテストケース
	class SuccessTestCase : public TestCase {
	public:
		// コンストラクタ
		explicit SuccessTestCase() : TestCase("SuccessTestCase"){}
		// テスト
		virtual void runTest(){ TestAssert(true); }
	};

	// 失敗するテストケース
	class FailureTestCase : public TestCase {
	public:
		// コンストラクタ
		explicit FailureTestCase() : TestCase("FailureTestCase"){}
		// テスト
		virtual void runTest(){ TestAssert(false); }
	};

	// 失敗するメッセージテストケース
	class FailureMessageTestCase : public TestCase {
	public:
		// コンストラクタ
		explicit FailureMessageTestCase() :
			TestCase("FailureMessageTestCase"){}
		// テスト
		virtual void runTest(){ TestAssertMessage(false, "Failure"); }
	};

	// セットアップで失敗するテストケース
	class SetUpFailureTestCase : public TestCase {
	public:
		// コンストラクタ
		explicit SetUpFailureTestCase() : TestCase("SetUpFailureTestCase"){}
		// セットアップ
		virtual void setUp(){ TestAssert(false); }
		// テスト
		virtual void runTest(){}
	};

	// ティアーダウンで失敗するテストケース
	class TearDownFailureTestCase : public TestCase {
	public:
		// コンストラクタ
		explicit TearDownFailureTestCase() :
			TestCase("TearDownFailureTestCase"){}
		// テスト
		virtual void runTest(){}
		// ティアーダウン
		virtual void tearDown(){ TestAssert(false); }
	};

private:

};

//------------------------------------------------------------------------------
#endif // End of TEST_CASE_TEST_H_
//------------------------------------------------------------------------------
